option explicit

'  ozi2tab.vbs OziMapfile [MapInfoCoordSysString] [MapInfoUnitName]
'     OziMapfile     MapInfo,       "Moving Map Parameters = MM" 
'	OziMapfile -    OziMapfile
'   MapInfoCoordSysString -     MapInfo   , 
'		 , "CoordSys Earth Projection 1, 1001"
'   MapInfoUnitName - ,        OziMapfile,  
'		 , "degree"
'       
'       MapInfoCoordSysString   MapInfoUnitName  :
'       MapInfoCoordSysString="CoordSys Earth Projection 1, 1001"
'       MapInfoUnitName=degree
'       
'   :    
'		*	    
'		ozi2tab.vbs 1.map "CoordSys Earth Projection 1, 1001" degree
'		ozi2tab.vbs 1.map "CoordSys Earth Projection 1, 1001" 
'		ozi2tab.vbs 1.map 
'
'	 
'		ozi2tab.vbs 1.map "CoordSys Earth Projection 1, 104"  - WGS84/degree
'		ozi2tab.vbs 1.map "CoordSys Earth Projection 8, 104, "m", 39, 0, 0.9996, 500000, 0" m - "UTM Zone 37, Northern Hemisphere (WGS 84)\p32637"/meter
'
'


main

function cFullHelp()
	dim strFullHelp 
	strFullHelp= " ozi2tab.vbs. " & vbnewLine & _
	"' :" & vbnewLine & _
	"'	ozi2tab.vbs OziMapfile [MapInfoCoordSysString] [MapInfoUnitName]" & vbNewLine & _
	"'     OziMapfile     MapInfo,     ""Moving Map Parameters = MM""" & vbNewLine & _
	"'	OziMapfile -    OziMapfile " & vbNewLine & _
	"'	MapInfoCoordSysString -     MapInfo   , " & vbNewLine & _
	"'		 , ""CoordSys Earth Projection 1, 1001""" & vbNewLine  & _
	"'		        ""CoordSys Earth Projection 8, 104, ''m'', 39, 0, 0.9996, 500000, 0""" & vbNewLine  & _
	"'	MapInfoUnitName - ,        OziMapfile " & vbNewLine & _
	"'		 , ""degree""" & vbNewLine  & _
	"'" & vbNewLine & _
	"!!! :         : "" -> ''.     . "	 & vbNewLine & _
	"'     MapInfoCoordSysString   MapInfoUnitName  : " & vbNewLine & _
	"'	MapInfoCoordSysString=""CoordSys Earth Projection 1, 1001""" & vbNewLine  & _
	"'	MapInfoUnitName=degree " & vbNewLine  & _
	"'       " & vbNewLine & _
	"' :    " & vbNewLine  & _
	"'	**      " & vbNewLine  & _
	"'	ozi2tab.vbs 1.map ""CoordSys Earth Projection 1, 1001"" degree " & vbNewLine  & _
	"'	ozi2tab.vbs 1.map ""CoordSys Earth Projection 1, 1001""" & vbNewLine & _
	"'	ozi2tab.vbs 1.map" & vbNewLine  & _
	"'"  & vbNewLine & _
	"'	 :" & vbNewLine  & _
	"'	ozi2tab.vbs 1.map ""CoordSys Earth Projection 1, 104"""  & vbnewline & _
	"'			- WGS84/degree" & vbNewLine & _
	"'	ozi2tab.vbs 1.map ""CoordSys Earth Projection 8, 104, ''m'', 39, 0, 0.9996, 500000, 0"" ""m"""  & vbnewline & _
	"'			- ""UTM Zone 37, Northern Hemisphere (WGS 84)\p32637""/meter " & vbNewLine
	
	cFullHelp=strFullHelp
end function


const cMsg000a="Starting File : "
const cMsg000z="Closing  File : "
const cMsg001="  File is Ozi Map file "
const cMsg002="  Output geoFile : """
const cMsg003="  Wrong file extention. Default extention 'twf' will be used."


const cErr001="  ###001: Wrong File format. File : "
const cErr002="  ###002: Parsing was breaked As reached unknow Cmd state : "
const cErr003="  ###003: Control points creation braked : "

const cDefaultCoordsystem="CoordSys Earth Projection 1, 1001"  '' Pulkovo 1942
const cDefaultUnits="degree"

'
' Main execution starts here
'
sub main
	dim bReadNext
    dim oArgs,FSO,Text1,Text2
    dim iIndex,i,str,s1,s2,fInPath,fOutPath,num,j,iArr
    dim iCmd
	dim iRasterName,iRasterExt
	dim iResCode 
	dim iNumCP, iStrCP()
	dim strCoordSys, strUnits

	set oArgs = Wscript.Arguments
	if oArgs.count > 4 or oArgs.count < 1 then
	    wscript.echo " : " & vbnewline & WScript.ScriptName & " OziMapFile [""MapInfo_Coordsystem_String""] [""Units_as_MapInfo_UnitName""]" & vbnewLine & _
	    vbnewLine & _
	    " : " & vbnewline & WScript.ScriptName & " -?" & 	    vbnewLine & _
		"!!! :         : "" -> ''.     . "
	    wscript.quit(-99999)
	end if
	iResCode=-9999

	fInPath=oArgs(0)
	if fInPath="/?" or fInPath="-?" or fInPath="/h" or fInPath="-h" or fInPath="?" then
	    wscript.echo cFullHelp
	    wscript.quit(-99999)
	end if
	REM CoordSys Earth Projection 1, 104
	REM Units "degree"
	if oArgs.count < 3 then
		strUnits=cDefaultUnits 
	else
		strUnits=oArgs(2)
	end if
	if oArgs.count < 2 then
		strCoordSys=cDefaultCoordsystem 
	else
		strCoordSys=oArgs(1)
	end if
	
	strUnits = replace(strUnits,"""","")
	strUnits = replace(strUnits,"''","""")
	strCoordSys=replace(strCoordSys,"""","")
	strCoordSys=replace(strCoordSys,"''","""")
	fInPath=replace(fInPath,"""","")
	fInPath=replace(fInPath,"''","""")
	on error resume next

	if err then
    	    wscript.echo "Error" & " 1"
    	    wscript.quit(1)
	end if
	on error goto 0

	Set FSO = CreateObject("Scripting.FileSystemObject")
	fInPath=FSO.GetAbsolutePathName(fInPath)
	Set Text1 = FSO.OpenTextFile(fInPath, 1,False,0)
	iCmd=0	

	wscript.echo cMsg000a & """" & fInPath & """" & " At " & Time()
	bReadNext=True
	do until Text1.AtEndOfStream
	    if bReadNext then str=Text1.ReadLine	
		bReadNext=True
		if len(str)>0 then
		    select case iCmd
		       case 0
					' is it Ozi file
					if instr(str,"OziExplorer Map Data File") then
						wscript.echo cMsg001 & mid(str,len("OziExplorer Map Data File")+1)
						iCmd=1
					else
						wscript.echo cErr001 
						iResCode= - iCmd
						exit do
					end if
		       case 1
					' Output geoFile Name
					i=instr(str,".")
					if i > 0 then
						iRasterName=left(str,i-1)
					else
						iRasterName=str
					end if
					iRasterExt=".TAB"
					fOutPath=left(fInPath,len(fInPath)-len(str)) & iRasterName & iRasterExt
					wscript.echo cMsg002 & fOutPath & """"
					'''
					if FSO.FileExists(fOutPath) then Text2 = FSO.DeleteFile(fOutPath, True)

					Set Text2 = FSO.CreateTextFile(fOutPath, True, False)
					text2.WriteLine  "!table"
					text2.WriteLine  "!version 300"
					text2.WriteLine  "!charset WindowsCyrillic"
					text2.WriteLine  
					text2.WriteLine  "Definition Table"
					text2.WriteLine  "  File """ & str & """"
					text2.WriteLine  "  Type ""RASTER"""
					iCmd=2
				case 2
				' search for 'MM0,Yes' string
					if strcomp(str,"MM0,Yes") = 0 then iCmd=3
				case 3
				' search for 'MMPNUM,' string
					i=strcomp(str,"MMPNUM,")
					if i <> 0 then 
						iNumCP=clng(mid(str,len("MMPNUM,")+1))
						'' wscript.echo "    iNumCP= " & iNumCP
						redim iStrCP(iNumCP,5)
						iIndex=0
						iCmd=4
					end if
				case 4
				' search and iterate 'MMPXY,' strings
				' MMPXY,1,27,17
					i=instr(str,"MMPXY,")
					if i = 0 or iIndex >= iNumCP then 
						bReadNext=False
						iIndex=0
						iCmd=5
					else
						iArr=Split(mid(str,len("MMPXY,")+1),",")
						for i=0 to 2
							iStrCP(iIndex,i)=iArr(i)
						next
						iIndex=iIndex+1
					end if
				case 5
				' search and iterate 'MMPLL,' strings
				' MMPLL,1,  30.000000,  60.000000
					i=instr(str,"MMPLL,")
					if i = 0 or iIndex >= iNumCP then 
						bReadNext=False
						iCmd=6
					else
						iArr=Split(mid(str,len("MMPLL,")+1),",")
						if Clng(iArr(0)) = Clng(iStrCP(iIndex,0)) then
							for i=1 to 2
								iStrCP(iIndex,i+2)=iArr(i)
							next
							iIndex=iIndex+1
						end if
					end if
				case 6
				' Output all Control Points
					str=""
					s2=""
					if iIndex > 0 then
						  REM (30,60) (448,131) Label "Pt 1",
						  REM (150,60) (675,131) Label "Pt 2",
						  REM (60,30) (505,206) Label "Pt 3",
						  REM (120,30) (618,206) Label "Pt 4"
						for i=0 to iIndex-1
							s2="  (" & iStrCP(i,3) & "," & iStrCP(i,4) & ") (" & iStrCP(i,1) & "," & iStrCP(i,2) & ") Label ""Pt_" & iStrCP(i,0) & """"
							if i <> (iIndex-1) then s2=s2 & ","
							text2.WriteLine  s2
						next
						REM CoordSys Earth Projection 1, 104
						REM Units "degree"
						s2="  " & strCoordSys
						text2.WriteLine  s2
						s2="  Units """ & strUnits & """"
						text2.WriteLine  s2


					if iIndex <> iNumCP then
							wscript.echo cErr003 & iIndex & " <> " & iNumCP
							iResCode= - iCmd
						else 
							iResCode=0
						end if
					end if
					exit do
				case else
					wscript.echo cErr002 & iCmd
					iResCode= - iCmd
					exit do
		    end select
		end if
	loop

	
	text1.close
	if not isnull(text2) then text2.close
    
 	wscript.echo cMsg000z & """" & fInPath & """" & " At " & Time()
	wscript.quit(iResCode)

ExitSub:
    set FSO=Nothing
    exit Sub
end sub         	

